unit Ffactwin;

{ This application shows how to display Paradox style memo and graphic
 fields in a form. Table1's DatabaseName property should point to the
 Delphi sample database. Table1's TableName property should be set to
 the BIOLIFE table. }

{ Additional note by the Author of Yapi

  The program has been modified for printout using Yapi (yet another printer
  interface).
  The modifications are as follows:
     To the form:
        1. A yapi paper was dropped on the form
        2. Three tabs were dropped on the paper and moved into position
           These were for:
              The start position of the indented memo
              The end position for the indented memo
              The start postion for the pictures
        3. Four yapi text were placed on the form, renamed and their
           fonts setup. The yapi text for the "memo" was set to wrap
           between tabs.
        5. A yapi image was placed on the form for the pictures
        6. A footer was dropped on the form and setup
        7. A report button was placed on the form
     To the software
        All of the code is in a single method "ReportButtonClick"
        which is an event for the report button.
}

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, DBCtrls, DBGrids, DB, DBTables, Buttons, Grids, ExtCtrls,
  yapi;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    DBImage1: TDBImage;
    DBLabel1: TDBText;
    DBMemo1: TDBMemo;
    DataSource1: TDataSource;
    Table1: TTable;
    Table1Common_Name: TStringField;
    Table1Graphic: TBlobField;
    DBGrid1: TDBGrid;
    BitBtn1: TBitBtn;
    Table1Category: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    ReportButton: TButton;
    Paper: TyapiPaper;
    Image: TyapiImage;
    yapiTab1: TyapiTab;
    Title: TyapiText;
    Memo: TyapiText;
    yapiTab2: TyapiTab;
    yapiTab3: TyapiTab;
    Heading: TyapiText;
    Text: TyapiText;
    Fixed: TyapiText;
    Footery: TyapiHeaderFooter;
    SourceMemo: TMemo;
    procedure ReportButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ReportButtonClick(Sender: TObject);
var
   i:Integer;
   s:string;
begin
   paper.clear;
   Heading.writeln('Fish Facts');
   Heading.writeln;
   paper.drawline(memo.font);
   Table1.First;
   while not Table1.eof do begin
        Title.writeln(Table1.fieldbyname('Common_name').asstring);
        Text.writeln(
               'Category: '+
               Table1.fieldbyname('Category').asstring+', '+
               'Species Name: '+
               Table1.fieldbyname('Species Name').asstring+', '+
               'L='+format('%.1f',[Table1.fieldbyname('Length_In').asfloat])+
               ' in, '+
                format('%.0f',[Table1.fieldbyname('Length (cm)').asfloat])+
                ' cm');
       memo.writeln;
       s:=Table1.fieldbyname('Notes').asstring;
       memo.writeattab(s,1);
       Image.writeattab(3,DBImage1.Picture);
       memo.writeln;
       memo.writeln;
       paper.drawline(memo.font);
       Table1.next
   end;
   Table1.First;
   paper.newpage;
   Heading.writeln(
     'Listing for the the program that produced this printout');
   for i:=0 to sourcememo.lines.count-1 do
      fixed.writeln(sourcememo.lines[i]);
   paper.preview;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  sourcememo.visible:=false;
end;

{
 the most deceptive line in this program is

        memo.writeattab(s,1);

This line takes the multiline contents of the memo and word wraps it
between tabs 1 and 2. There are two "write" on the same line. The write
of the memo and the write of the picture. Note that the line spacing
algorithm allows for the maximum of the memo height or the picture height.
}

end.


